VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CBroker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Setting: Requires a transactions
Option Explicit

Function SubmitOrder(ByVal Customer As String, ByVal Product As String, ByVal Quantity As Long, ByRef OrderStatus As String) As Long

  On Error GoTo SubmitError

  Dim ObjCtx As ObjectContext
  Set ObjCtx = GetObjectContext()

  Dim Products As CProducts, Price As Currency
  Dim Customers As CCustomers
  Dim Orders As COrders, OrderNumber As Long
  
  Set Products = ObjCtx.CreateInstance("Market.CProducts")
  Set Customers = ObjCtx.CreateInstance("Market.CCustomers")
  Set Orders = ObjCtx.CreateInstance("Market.COrders")
  
  Price = Products.Purchase(Product, Quantity)
  
  Customers.Charge Customer, Price
  OrderNumber = Orders.Add(Customer, Product, Quantity, Price)
  OrderStatus = "Your order for " & Quantity & " " & LCase(Product) & _
                " at a total cost of " & Format(Price, "$#,##0.00") & " has been accepted." & _
                " Your order number is " & OrderNumber
  
  SubmitOrder = OrderNumber
  ObjCtx.SetComplete
Exit Function
SubmitError:
  ObjCtx.SetAbort
  Err.Raise Err.Number, , Err.Description
End Function
