VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "COrders"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Setting: Supports transactions
Option Explicit

Public Function Add(ByVal Customer As String, ByVal Product As String, ByVal Quantity As Long, ByVal Price As Currency) As Long

  Dim ObjCtx As ObjectContext
  Set ObjCtx = GetObjectContext()

  ' process order
  Dim conn As New ADODB.Connection
  conn.Open sConnect

  ' add order to orders table
  Dim cmdAddOrder As New ADODB.Command
  cmdAddOrder.Prepared = False
  cmdAddOrder.CommandText = "AddOrder"
  cmdAddOrder.CommandType = adCmdStoredProc
  
  ' set up parameters for stored procedure
  Dim prmCustomer As ADODB.Parameter
  Set prmCustomer = cmdAddOrder.CreateParameter("@Customer", adBSTR, adParamInput, , Customer)
  cmdAddOrder.Parameters.Append prmCustomer
  Dim prmProduct As ADODB.Parameter
  Set prmProduct = cmdAddOrder.CreateParameter("@Product", adBSTR, adParamInput, , Product)
  cmdAddOrder.Parameters.Append prmProduct
  Dim prmQuantity As ADODB.Parameter
  Set prmQuantity = cmdAddOrder.CreateParameter("@Quantity", adInteger, adParamInput, , Quantity)
  cmdAddOrder.Parameters.Append prmQuantity
  Dim prmPrice As ADODB.Parameter
  Set prmPrice = cmdAddOrder.CreateParameter("@Price", adCurrency, adParamInput, , Price)
  cmdAddOrder.Parameters.Append prmPrice
  Dim prmOrderNumber As ADODB.Parameter
  Set prmOrderNumber = cmdAddOrder.CreateParameter("@OrderNumber", adInteger, adParamOutput)
  cmdAddOrder.Parameters.Append prmOrderNumber
  
  ' associate connection and execute stored procedure
  Set cmdAddOrder.ActiveConnection = conn
  cmdAddOrder.Execute
  
  ' return order number to caller
  If prmOrderNumber.Value > 0 Then
    Add = prmOrderNumber.Value
  End If
  
  conn.Close
  
  ObjCtx.SetComplete

End Function
